# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:          # List of stages for jobs, and their order of execution
  - build
  - test

build-job:       # This job runs in the build stage, which runs first.
  tags:
    - vm-shell
  stage: build
  script:
    - echo "Creating virtual environment for App."
    - python3 -m venv py_env
    - source $(pwd)/py_env/bin/activate
    - echo "Install dependencies"
    - pip install -r requirements.txt
    - deactivate
  artifacts:
    paths:
      - py_env/

unit-test-job:   # This job runs in the test stage.
  tags:
    - vm-shell
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Activating virtual environment"
    - source $(pwd)/py_env/bin/activate
    - echo "Running unit tests."
    - python manage.py test main
    - echo "Checking the server..."
    - python manage.py runserver &
    - sleep 10
    - wget -O - localhost:8000 > /dev/null && echo "Server is Up"
    - pkill python
    - deactivate
    - echo "All tests successfully passed."


